/*
	Rutina que ejecuta una aplicacion en el Microcontrolador.

	(C) 1994 Ibercomp S.R.L. - A. Miguel
	Julio de 1994
*/

unsigned char buffer[32768];


	
ejecuta_eforth()
    {
	reseteo();
	vacia_rs232c();
	
	envia_binario(fich,32768);

	ejecuta(33024);
}

ejecuta(unsigned short direccion)
{
	unsigned char d_alta,d_baja;
	unsigned char crc=0;
	unsigned char recibido;
	
	printf("Contador de Programa (PC): %05u - $%04X\n\r",(unsigned int)direccion,(unsigned int)direccion);
	
	d_alta=direccion/256;
	d_baja=direccion & 0x00FF;

	crc+=d_alta;
	crc+=d_baja;
	
	envia_rs232c(134);
	envia_rs232c(d_alta);
	envia_rs232c(d_baja);
	envia_rs232c(crc);
	
	recibido=recibe_rs232c();
	
	if (recibido==134) {
	     /*   printf("\n\rEl programa se ejecuto en el Microcontrolador\n\r");    */
	     terminal_eforth();
	}
	else {
		printf("ERROR: El programa no pudo ejecutarse\n\r");
		printf("       El microcontrolador no responde\n\r");
	}
}

envia_binario(char *fichero,unsigned short direccion)
{
	FILE *canal;
	int leido;
	long x;
	unsigned short crc=0;
	unsigned char d_alto,d_bajo,l_alto,l_bajo;
	unsigned char recibido;
	
	canal=fopen(fichero,"rb");
	if (!canal) {
		printf("No pudo abrirse el fichero binario ERROR del DOS: %d\n\r",canal);
		exit((unsigned int)canal);
	}
	leido=fread(buffer,1,32767,canal);
	fclose(canal);

	printf("Fichero binario          : %s\n\r",fichero);
	printf("Longitud del fichero     : %05u - $%04X\n\r",(unsigned int)leido,(unsigned int)leido);
	printf("Direccion en ALTAIR 535  : %05u - $%04X\n\r",(unsigned int)direccion,(unsigned int)direccion);

	d_alto=direccion/256;
	d_bajo=direccion & 0x00FF;
	l_alto=leido/256;
	l_bajo=leido & 0x00FF;

	envia_rs232c(131);
	envia_rs232c(d_alto);
	envia_rs232c(d_bajo);
	envia_rs232c(l_alto);
	envia_rs232c(l_bajo);
	crc+=d_alto;
	crc+=d_bajo;
	crc+=l_alto;
	crc+=l_bajo;
	
	for (x=0;x<leido;x++) {
		crc+=buffer[x];
		envia_rs232c(buffer[x]);        
	}
	
	envia_rs232c(crc);
	
	recibido=recibe_rs232c();
	
	if (recibido==131) {
		printf("\n\rLa transmision del programa fue correcta.\n\n\r",(unsigned int)recibido);
	}
	else {
		printf("No pudo transmitirse el programa\n\r");
		exit(0);
	}
}
